#include <iostream>
#include <string>
using namespace std;

typedef struct pacijent {
  int krvna_grupa;
  int kolicina;
}pacijent;

int main() {
  int a, b, o, ab;
  int n;
  pacijent pacijenti[10001]; 
  int resenje[10001][4];
  string krvna_grupa;
  int kolicina;

  cin >> n;
  cin >> o >> a >> b >> ab;

  for(int i = 0; i < n; i++){
    cin >> krvna_grupa>>kolicina;

    if(krvna_grupa[0] == 'O') {
      pacijenti[i].krvna_grupa = 0;
    }

    else if(krvna_grupa[0] == 'A' && krvna_grupa.size() == 1) {
      pacijenti[i].krvna_grupa = 1;
    }

    else if(krvna_grupa[0] == 'B') {
      pacijenti[i].krvna_grupa = 2;
    }
    
    else if(krvna_grupa[0] == 'A') {
      pacijenti[i].krvna_grupa = 3;
    }

    pacijenti[i].kolicina = kolicina;
  }

  for(int i = 0; i < n; i++) {
    if (pacijenti[i].krvna_grupa == 0) {
      
      o -= pacijenti[i].kolicina;      
      resenje[i][0] = pacijenti[i].kolicina;
      pacijenti[i].kolicina = 0;

      if (o < 0) {
        cout<<"nemoguce";
        return 0;
      }
    }
  }

  for(int i = 0; i < n; i++) {
    if (pacijenti[i].krvna_grupa == 1) {
      
      if (pacijenti[i].kolicina <= a){
        a -= pacijenti[i].kolicina;
        resenje[i][1] = pacijenti[i].kolicina;
        pacijenti[i].kolicina = 0;

      }else if (pacijenti[i].kolicina <= o + a){
        resenje[i][1] = a;
        resenje[i][0] = pacijenti[i].kolicina - a;
        o = o + a - pacijenti[i].kolicina;
        a = 0;
        pacijenti[i].kolicina = 0;
      }
      else {
        cout << "nemoguce";
        return 0;
      }
      
    }
  }


  for(int i = 0; i < n; i++) {
    if (pacijenti[i].krvna_grupa == 2) {
      
      if (pacijenti[i].kolicina <= b){
        b -= pacijenti[i].kolicina;
        resenje[i][2] = pacijenti[i].kolicina;
        pacijenti[i].kolicina = 0;

      }else if (pacijenti[i].kolicina <= o + b){
        resenje[i][2] = b;
        resenje[i][0] = pacijenti[i].kolicina - b;
        o = o + b - pacijenti[i].kolicina;
        b = 0;
        pacijenti[i].kolicina = 0;
      }
      else {
        cout << "nemoguce";
        return 0;
      }
      
    }
  }

  for(int i = 0; i < n; i++) {
    if (pacijenti[i].krvna_grupa == 3) {
      
      if (pacijenti[i].kolicina <= ab){
        ab -= pacijenti[i].kolicina;
        resenje[i][3] = pacijenti[i].kolicina;
        pacijenti[i].kolicina = 0;

      }else if (pacijenti[i].kolicina <= ab + a + b + o){
        resenje[i][3] = ab;
        pacijenti[i].kolicina -= ab;

        if (pacijenti[i].kolicina <= a) {
          resenje[i][1] = pacijenti[i].kolicina;
          a -= pacijenti[i].kolicina;
          pacijenti[i].kolicina = 0;
          continue;
        }

        else {
          resenje[i][1] = a;
          pacijenti[i].kolicina -= a;
          a = 0;
        }

        if (pacijenti[i].kolicina <= b) {
          resenje[i][2] = pacijenti[i].kolicina;
          b -= pacijenti[i].kolicina;
          pacijenti[i].kolicina = 0;
          continue;
        }

        else {
          resenje[i][2] = b;
          pacijenti[i].kolicina -= b;
          b = 0;
        }

        if (pacijenti[i].kolicina <= o) {
          resenje[i][0] = pacijenti[i].kolicina;
          o -= pacijenti[i].kolicina;
          pacijenti[i].kolicina = 0;
          continue;
        }

        else {
          resenje[i][0] = o;
          pacijenti[i].kolicina -= o;
          o = 0;
        }

        if (pacijenti[i].kolicina > 0){
          cout << "nemoguce" <<"\n";
          return 0;
        }
      }
      else {
        cout << "nemoguce";
        return 0;
      }
      
    }
  }

  cout<<"moguce"<<"\n";
  for (int i = 0; i < n; i++){
    for(int j = 0; j < 4; j++){
      cout<<resenje[i][j] << " ";
    }
    cout<<"\n";
  }

  return 0;
}